.include "supervision.inc"
.include "common.inc"

.zeropage
draw_lcd_addr: .word 0
; temporary
draw_font_addr: .word 0
string_addr: .word 0

;.data
draw_xpos: .byte 0
draw_ypos: .byte 0
; temporary
tword1: .word 0
tbyte1: .byte 0

.rodata
font:	
.incbin "cga2.chr"
draw_line_starts:.word 0, LCD_LINESIZE*8, LCD_LINESIZE*8*2, LCD_LINESIZE*8*3
		.word LCD_LINESIZE*8*4, LCD_LINESIZE*8*5, LCD_LINESIZE*8*6, LCD_LINESIZE*8*7
		.word LCD_LINESIZE*8*8, LCD_LINESIZE*8*9, LCD_LINESIZE*8*10, LCD_LINESIZE*8*11
		.word LCD_LINESIZE*8*12, LCD_LINESIZE*8*13, LCD_LINESIZE*8*14, LCD_LINESIZE*8*15
		.word LCD_LINESIZE*8*16, LCD_LINESIZE*8*17, LCD_LINESIZE*8*18, LCD_LINESIZE*8*19
hex2asc:	.byte "0123456789abcdef"



.code
.proc draw_clear_screen
	lda	#<lcd_addr
	sta	draw_font_addr
	lda	#>lcd_addr
	sta	draw_font_addr+1
	ldx	#160
loop1:
	lda 	#0
	ldy	#(160-1)/4
loop:
	sta	(draw_font_addr),y
	dey
	bpl	loop
	lda	#LCD_LINESIZE
	clc
	adc	draw_font_addr
	sta	draw_font_addr
	lda	#0
	adc	draw_font_addr+1
	sta	draw_font_addr+1
	dex
	bne	loop1
	rts
.endproc

.proc draw_set_cursor
	cpx	#20
	BLT	nolineoverflow
	txa
	sec
	sbc	#20
	tax
	iny
nolineoverflow:
	stx	draw_xpos
	sty	draw_ypos
	txa
	asl
	sta	draw_lcd_addr
	tya
	asl
	tay
	lda	draw_line_starts,y
	clc
	adc	draw_lcd_addr
	sta	draw_lcd_addr
	lda	draw_line_starts+1,y
	adc	#>lcd_addr
	sta	draw_lcd_addr+1
	rts
.endproc

.proc draw_char
	stz 	draw_font_addr+1
	asl
	rol 	draw_font_addr+1
	asl
	rol 	draw_font_addr+1
	asl
	rol	draw_font_addr+1
	clc
	adc	#<font
	sta	draw_font_addr
	lda	#>font
	adc	draw_font_addr+1
	sta	draw_font_addr+1
	ldy	#0
loopline:
	lda 	(draw_font_addr),y
	ldx	#8
loopcolumn:
	lsr
	php
	rol	tword1
	rol	tword1+1
	plp
	rol	tword1
	rol	tword1+1
	dex
	bne	loopcolumn
	phy
	ldy	#0
	lda	tword1
	sta	(draw_lcd_addr),y
	iny
	lda	tword1+1
	sta	(draw_lcd_addr),y
	ply
	lda	draw_lcd_addr
	clc
	adc	#LCD_LINESIZE
	sta	draw_lcd_addr
	lda	draw_lcd_addr+1
	adc	#0
	sta	draw_lcd_addr+1
	iny
	cpy	#8
	bne	loopline
	; pointing to next character

	sec
	lda	draw_lcd_addr
	sbc	#<(LCD_LINESIZE*8-2)
	sta	draw_lcd_addr
	lda	draw_lcd_addr+1
	sbc	#>(LCD_LINESIZE*8-2)
	sta	draw_lcd_addr+1
	rts
.endproc

.proc draw_hex
	sta	tbyte1
	lsr
	lsr
	lsr
	lsr
	tay
	lda	hex2asc,y
	jsr	draw_char
	lda	tbyte1
	and	#$f
	tay
	lda	hex2asc,y
	jmp	draw_char
.endproc

.proc draw_string
	sta	string_addr
	sty	string_addr+1
loop:
	lda	(string_addr)
	beq	end
	cmp	#DRAW_NEW_LINE
	beq	newline
	cmp	#DRAW_CLEAR_SCREEN
	beq	clearscreen
	cmp	#DRAW_HOME
	beq	home
	jsr	draw_char
loop1:
	lda	string_addr
	clc
	adc	#1
	sta	string_addr
	lda	string_addr+1
	adc	#0
	sta	string_addr+1
	bra	loop	
clearscreen:
	jsr	draw_clear_screen
home:
	ldx	#0
	ldy	#0
	jsr	draw_set_cursor
	bra	loop1
newline:
	ldy	draw_ypos
	iny
	ldx	#0
	jsr	draw_set_cursor
	bra	loop1
end:
	rts
.endproc
